// MemoryDCView.cpp : Implementierung der Klasse CMemoryDCView
//

#include "stdafx.h"
#include "MemoryDC.h"

#include "MemoryDCDoc.h"
#include "MemoryDCView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMemoryDCView

IMPLEMENT_DYNCREATE(CMemoryDCView, CView)

BEGIN_MESSAGE_MAP(CMemoryDCView, CView)
	// Standarddruckbefehle
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)

	ON_COMMAND(IDM_ZEICHNEN_DIREKT, OnZeichnenDirekt)
	ON_UPDATE_COMMAND_UI(IDM_ZEICHNEN_DIREKT, OnUpdateZeichnenDirekt)
	ON_COMMAND(IDM_ZEICHNEN_MEMORY, OnZeichnenMemory)
	ON_UPDATE_COMMAND_UI(IDM_ZEICHNEN_MEMORY, OnUpdateZeichnenMemory)
	ON_COMMAND(IDM_CLICK_ERASE_BACKGROUND, OnClickEraseBackground)
	ON_UPDATE_COMMAND_UI(IDM_CLICK_ERASE_BACKGROUND, OnUpdateClickEraseBackground)
	ON_WM_LBUTTONUP()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

// CMemoryDCView-Erstellung/Zerstrung

CMemoryDCView::CMemoryDCView()
{
	// TODO: Hier Code zur Konstruktion einfgen

	//In der View die Liste mit einer Liste zufllig erzeugter Punkte fllen.
	srand ( (unsigned int) time (NULL) );
	for (int intIndex = 0; intIndex < 1000; intIndex++)
	{
		CPoint pointNew;
		//X und y als Zufallswerte errechnen (zwischen 0 und 400).
		pointNew.x = rand () % 400;
		pointNew.y = rand () % 400;
		this->listPoints.AddTail (pointNew);
	}

	//Zeichenmodus setzen:
	this->bolZeichnenDirekt = TRUE;
	//Beim Mausklick den Hintergrund lschen:
	this->bolClickEraseBackground = TRUE;
}

CMemoryDCView::~CMemoryDCView()
{
}

BOOL CMemoryDCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CView::PreCreateWindow(cs);
}

// CMemoryDCView-Zeichnung

void CMemoryDCView::OnDraw(CDC* pDC)
{
	CMemoryDCDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: Code zum Zeichnen der systemeigenen Daten hinzufgen

	//Ermitteln der Fenstergre:
	CRect rectClient;
	this->GetClientRect(&rectClient);
	int intWidth = rectClient.right - rectClient.left;
	int intHeight = rectClient.bottom - rectClient.top;

	//Den weien Brush fr den Hintergrund anlegen:
	CBrush brushWhite;
	brushWhite.CreateSolidBrush ( RGB(255, 255, 255) );


	if (this->bolZeichnenDirekt == TRUE)
	{
		//-----------------------------------------------------------------------
		//           Variante 1: Die Liste der Punkte direkt zeichnen:
		//-----------------------------------------------------------------------
	
		//Ein weies Rechteck in dieser Farbe ber das gesamte Fenster zeichnen
		pDC->FillRect ( rectClient,  &brushWhite);
		
		for (int intPoint = 0; intPoint < this->listPoints.GetCount(); intPoint++)
		{
			CPoint pointAktuell = this->listPoints.GetAt ( this->listPoints.FindIndex ( intPoint) );
			pDC->Ellipse ( pointAktuell.x - 2, pointAktuell.y - 2, pointAktuell.x + 2, pointAktuell.y + 2);
		}
	}
	else
	{
		//-----------------------------------------------------------------------
		//           Variante 2: In MemoryDeviceContext zeichnen
		//-----------------------------------------------------------------------

		//In Memory-Device-Context, diesen dann in aktuellen Zeichencontext schieben.

		CDC dcMem;
		dcMem.CreateCompatibleDC(pDC);

		CBitmap *oldBitmap;

		CBitmap *bitmap = new CBitmap();
		
		//In Memory-DC zeichnen statt in "echtem" DeviceContext:
		//Bitmap von width*height Pixeln mit 32 Bit Farbtiefe erzeugen:
		bitmap->CreateBitmap ( intWidth, intHeight, 1, 32, NULL);

		//Kopieren der Bitmap in Temporren Device-Context:
		oldBitmap = dcMem.SelectObject (bitmap);

		//Hintergrund der Bitmap initialisieren.
		//Dazu ein weies Hintergrund-Rechteck zeichnen:
		dcMem.FillRect ( CRect (0, 0, intWidth, intHeight), &brushWhite);

		//In der leeren Bitmap ein paar Zeichenoperationen machen:
		for (int intPoint = 0; intPoint < this->listPoints.GetCount(); intPoint++)
		{
			CPoint pointAktuell = this->listPoints.GetAt ( this->listPoints.FindIndex ( intPoint) );
			dcMem.Ellipse ( pointAktuell.x - 2, pointAktuell.y - 2, pointAktuell.x + 2, pointAktuell.y + 2);
		}

		//Bitmap in Device-Context kopieren:
		BOOL bolResult = pDC->BitBlt(0,0, intWidth, 
			intHeight, &dcMem, 0, 0, SRCCOPY);

		dcMem.SelectObject (oldBitmap);

		dcMem.DeleteDC();

		delete bitmap;
	}
}


// CMemoryDCView drucken

BOOL CMemoryDCView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}

void CMemoryDCView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CMemoryDCView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Bereinigung nach dem Drucken einfgen
}


// CMemoryDCView-Diagnose

#ifdef _DEBUG
void CMemoryDCView::AssertValid() const
{
	CView::AssertValid();
}

void CMemoryDCView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMemoryDCDoc* CMemoryDCView::GetDocument() const // Nicht-Debugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMemoryDCDoc)));
	return (CMemoryDCDoc*)m_pDocument;
}
#endif //_DEBUG


// CMemoryDCView-Meldungshandler


/**Menpunkt "Direktes Zeichnen" wird gewhlt: entsprechende Membervariable
 * setzen.
 */
void CMemoryDCView::OnZeichnenDirekt()
{
	this->bolZeichnenDirekt = TRUE;
}

/**Menpunkt "Direktes Zeichnen" soll angepat werden: Checked-State aus 
 * entsprechende Membervariable setzen.
 */
void CMemoryDCView::OnUpdateZeichnenDirekt(CCmdUI *pCmdUI)
{
	//pCmdUI->SetCheck ( this->bolZeichnenDirekt);
	pCmdUI->SetRadio ( this->bolZeichnenDirekt);
}

/**Menpunkt "Zeichnen in Memory-DC" wird gewhlt: entsprechende Membervariable
 * setzen.
 */
void CMemoryDCView::OnZeichnenMemory()
{
	this->bolZeichnenDirekt = FALSE;
}

/**Menpunkt "Direktes Zeichnen" soll angepat werden: Checked-State aus 
 * entsprechende Membervariable setzen.
 */
void CMemoryDCView::OnUpdateZeichnenMemory(CCmdUI *pCmdUI)
{
	//pCmdUI->SetCheck ( (this->bolZeichnenDirekt == FALSE) );
	pCmdUI->SetRadio ( this->bolZeichnenDirekt == FALSE);
}

/**Menpunkt "Beim Klick den Hintergrund lschen" wird gewhlt: entsprechende Membervariable
 * setzen.
 */
void CMemoryDCView::OnClickEraseBackground()
{
	this->bolClickEraseBackground = !this->bolClickEraseBackground;
}

/**Menpunkt "Beim Klick den Hintergrund lschen" soll angepat werden: Checked-State aus 
 * entsprechende Membervariable setzen.
 */
void CMemoryDCView::OnUpdateClickEraseBackground(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck ( this->bolClickEraseBackground);
}

/**DefWindowProc ist berladen, um das Zeichnen des Hintergrunds und damit
 * das nervige Flackern zu verhindern.
 * @param message Zu verarbeitende Message, hier passiert nur etwas bei WM_ERASEBKGND
 * @param wParam fr uns uninteressant.
 * @param lParam fr uns uninteressant.
 * @return Bei WM_ERASEBKGND "0" (Message verarbeitet), sonst den Rckgabewert
 * der Basisklassenmethode.
 */
LRESULT CMemoryDCView::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: Add your specialized code here and/or call the base class
	
	//Wenn die Erase-Background-Message kommt, dann wird "0" zurckgegeben, damit nichts
	//passiert. 
	//Dadurch hat das Fenster berhaupt keinen Hintergrund. 
	//Aus Doku: 
	//In der WindowClass gibt es einen Member hbrBackground, der die Hintergrundfarbe 
	//des Fensters angibt.
	//
	//If hbrBackground is NULL, the application should process the WM_ERASEBKGND message and erase the background. 
	//
	//Da hbrBackground nur beim Registrieren einer Fensterklasse auf NULL gesetzt werden kann,
	//fangen wir halt die System-Message ab und ignorieren sie.
	//Nur ignorieren wenn der User dies so wnscht.
	if (this->bolClickEraseBackground == FALSE)
	{
		if (message == WM_ERASEBKGND)
			return 0;
		else
			return CView::DefWindowProc(message, wParam, lParam);
	}
	else
		return CView::DefWindowProc(message, wParam, lParam);
}

/**Klick mit dem linken Mausbutton: Refresh der Anzeige.
 * Ob der Hintergrund auch gelscht wird entscheidet der User.
 * @param nFlags Klick-Info, uninteressant.
 * @param point Wo ?
 */
void CMemoryDCView::OnLButtonUp(UINT nFlags, CPoint point)
{
	CView::OnLButtonUp(nFlags, point);

	//Je nach Meneinstellung den Hintergrund auch lschen.
	this->Invalidate (this->bolClickEraseBackground);
}