// MemoryDCView.h : Schnittstelle der Klasse CMemoryDCView
//


#pragma once


class CMemoryDCView : public CView
{
protected: // Nur aus Serialisierung erstellen
	CMemoryDCView();

	//Die Liste der zu zeichnenden Punkte.
	CList <CPoint, CPoint &> listPoints;
	//Zeichenmodus (Direkt oder im Memory-DC)
	BOOL bolZeichnenDirekt;
	//Soll beim Mausklick der Hintergrund ebenfalls gelscht werden ?
	BOOL bolClickEraseBackground;

	DECLARE_DYNCREATE(CMemoryDCView)

// Attribute
public:
	CMemoryDCDoc* GetDocument() const;

// Vorgnge
public:

// berschreibungen
public:
	virtual void OnDraw(CDC* pDC);  // berschrieben, um diese Ansicht darzustellen
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementierung
public:
	virtual ~CMemoryDCView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Funktionen fr die Meldungstabellen
protected:
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnZeichnenDirekt();
	afx_msg void OnUpdateZeichnenDirekt(CCmdUI *pCmdUI);
	afx_msg void OnZeichnenMemory();
	afx_msg void OnUpdateZeichnenMemory(CCmdUI *pCmdUI);
	afx_msg void OnClickEraseBackground();
	afx_msg void OnUpdateClickEraseBackground(CCmdUI *pCmdUI);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	
protected:
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);

};

#ifndef _DEBUG  // Debugversion in MemoryDCView.cpp
inline CMemoryDCDoc* CMemoryDCView::GetDocument() const
   { return reinterpret_cast<CMemoryDCDoc*>(m_pDocument); }
#endif

